#include "file.h"
#include "libmy/gbfs.h"


//---------------------------------------------------------------------------
const char* const FileScoTable[FILE_MAX_SCO_CNT] = {
	"#SYSTEM35",			// 0
	".sco",				// 1
	"2.sco",
	"tO.sco",
	"MES_SUB.sco",
	"XSPEC.sco",			// 5
	".sco",
	".sco",
	"bfo^.sco",
	"CGMODE.sco",
	"ؽ.sco",				// 10
	"Ƃ.sco",
	"lp.sco",
	"c.sco",
	"j.sco",
	".sco",				// 15
	"v`n.sco",
	".sco",
	"Od.sco",
	"D.sco",
	"y.sco",				// 20
	"ݸ.sco",
	"A۰.sco",
	"A.sco",
	"Aꌩ.sco",
	"Al.sco",			// 25
	"Ab.sco",
	"A.sco",
	"A.sco",
	"Al.sco",
	"Ab.sco",			// 30
	"AX.sco",
	"AX.sco",
	"AX.sco",
	"AXb.sco",
	"AXl.sco",			// 35
	"A.sco",
	"A.sco",
	"Al.sco",
	"Ab.sco",
	"AVl.sco",			// 40
	"AVl.sco",
	"AVll.sco",
	"AVlb.sco",
	"A.sco",
	"A.sco",				// 45
	"AΉ.sco",
	"A퓬01.sco",
	"A퓬02.sco",
	"AVlŌ.sco",
	"AŏI.sco",			// 50
	"B۰.sco",
	"BfA{J.sco",
	"BX.sco",
	"BX.sco",
	"BXb.sco",			// 55
	"BXl.sco",
	"BW[.sco",
	"BW[.sco",
	"BW[b.sco",
	"BW[l.sco",		// 60
	"BW[d.sco",
	"BAY.sco",
	"BAY.sco",
	"BAYb.sco",
	"BAYl.sco",			// 65
	"BMh.sco",
	"BMh.sco",
	"BMhl.sco",
	"BMhb.sco",
	"Bd01.sco",			// 70
	"Bd02.sco",
	"Bd03.sco",
	"Bd04.sco",
	"BG.sco",
	"B.sco",				// 75
	"BVn.sco",
	"BŏI.sco",
	"C۰.sco",
	"C.sco",
	"Cb.sco",			// 80
	"Cꌩ.sco",
	"Cl.sco",
	"CiR.sco",
	"CiRb.sco",
	"CiR.sco",			// 85
	"CiRl.sco",
	"C.sco",
	"Cb.sco",
	"C.sco",
	"Cl.sco",			// 90
	"CS.sco",
	"CSb.sco",
	"CS.sco",
	"CSl.sco",
	"Cr.sco",			// 95
	"Crb.sco",
	"Cr쌩.sco",
	"Crl.sco",
	"CX.sco",
	"CX.sco",			// 100
	"CXb.sco",
	"CXl.sco",
	"C.sco",
	"CfA{J.sco",
	"CÎE.sco",			// 105
	"CŏI.sco",
	"D۰.sco",
	"DX.sco",
	"DX.sco",
	"DXb.sco",			// 110
	"DXl.sco",
	"D.sco",
	"D.sco",
	"Db.sco",
	"Dl.sco",			// 115
	"D.sco",
	"Dٌ.sco",
	"D٘b.sco",
	"Dٍl.sco",
	"D.sco",				// 120
	"D.sco",
	"DP.sco",
	"DfA{J.sco",
	"D.sco",
	"DŏI.sco",			// 125
	"E۰.sco",
	"EՖ{.sco",
	"E.sco",
	"EՌ.sco",
	"E՘b.sco",			// 130
	"EՍl.sco",
	"EfC.sco",
	"EfC.sco",
	"EfCb.sco",
	"EfCl.sco",		// 135
	"EeBVA.sco",
	"EeBVA.sco",
	"EeBVAb.sco",
	"EeBVAl.sco",
	"EwZ.sco",			// 140
	"EwZ.sco",
	"EwZb.sco",
	"EwZl.sco",
	"EX.sco",
	"EX.sco",			// 145
	"EXb.sco",
	"EXl.sco",
	"EP.sco",
	"EŏI.sco",
	"F۰.sco",			// 150
	"FfA{J.sco",
	"FX.sco",
	"FX.sco",
	"FXb.sco",
	"FXl.sco",			// 155
	"FX.sco",
	"FX.sco",
	"FXb.sco",
	"FXl.sco",
	"FH.sco",			// 160
	"FH.sco",
	"FHb.sco",
	"FHl.sco",
	"FG.sco",
	"FG݌.sco",			// 165
	"FGݘb.sco",
	"FGݍl.sco",
	"F.sco",
	"FŏI.sco",
	"G۰.sco",			// 170
	"GPX.sco",
	"GPX.sco",
	"GPXb.sco",
	"GPXl.sco",
	"Gr.sco",			// 175
	"Gr쌩.sco",
	"Grb.sco",
	"Grl.sco",
	"GQX.sco",
	"GQX.sco",			// 180
	"GQXb.sco",
	"GQXl.sco",
	"GX.sco",
	"GX.sco",
	"GXb.sco",			// 185
	"GXl.sco",
	"G.sco",
	"Gٌ.sco",
	"G٘b.sco",
	"Gٍl.sco",			// 190
	"G.sco",
	"G댩.sco",
	"Gb.sco",
	"Gl.sco",
	"G.sco",			// 195
	"G.sco",
	"Gb.sco",
	"Gl.sco",
	"GAAX.sco",
	"G.sco",			// 200
	"G.sco",
	"Gt@g.sco",
	"Gdc.sco",
	"GSh[.sco",
	"GΉ.sco",			// 205
	"GV.sco",
	"GŏI.sco",
	"ިݸ.sco",
};


//---------------------------------------------------------------------------
EWRAM_CODE void FileInit(void)
{
	// EMPTY
}
//---------------------------------------------------------------------------
EWRAM_CODE u8* FileGetSco(u32 num)
{
	char buf[32];
	_Sprintf(buf, "%03d.sco", num);

	return GbfsGetSafePointer(buf);
}
//---------------------------------------------------------------------------
EWRAM_CODE u8* FileGetImg(u32 num)
{
	char buf[32];
	_Sprintf(buf, "CG%03d.img", num);

	return GbfsGetSafePointer(buf);
}
//---------------------------------------------------------------------------
EWRAM_CODE u8* FileGetImgMask(u32 num)
{
	char buf[32];
	_Sprintf(buf, "CG%03dM.img", num);

	return GbfsGetSafePointer(buf);
}
//---------------------------------------------------------------------------
EWRAM_CODE u8* FileGetMus(u32 num)
{
	char buf[32];
	_Sprintf(buf, "tr_%03d.8ad", num);

	return GbfsGetSafePointer(buf);
}
//---------------------------------------------------------------------------
EWRAM_CODE u8* FileGetSe(u32 num)
{
	char buf[32];
	_Sprintf(buf, "DIABO%02d.raw", num);

	return GbfsGetSafePointer(buf);
}
//---------------------------------------------------------------------------
EWRAM_CODE char* FileGetScoStr(u32 num)
{
	_ASSERT(num < FILE_MAX_SCO_CNT);

	return (char*)FileScoTable[num];
}
//---------------------------------------------------------------------------
EWRAM_CODE u32 FileGetSize(void)
{
	return GbfsGetFileSize();
}
//---------------------------------------------------------------------------
EWRAM_CODE bool FileIsMaskExist(u32 num)
{
	char buf[32];
	_Sprintf(buf, "CG%03dM.img", num);

	return (GbfsGetPointer(buf) == NULL) ? FALSE : TRUE;
}
