#include "img.h"
#include "libmy/mode3.h"
#include "libmy/fade.h"
#include "file.h"

//---------------------------------------------------------------------------
ST_IMG Img;


//---------------------------------------------------------------------------
EWRAM_CODE void ImgInit(void)
{
	_Memset(&Img, 0x00, sizeof(ST_IMG));

	ImgSetFade(4);
}
//---------------------------------------------------------------------------
EWRAM_CODE void ImgExec(void)
{
	if(ImgIsEnd() == TRUE)
	{
		return;
	}

	ImgExecDrawEffect();
	ImgExecDrawFace();
	ImgExecDraw();
}
//---------------------------------------------------------------------------
EWRAM_CODE void ImgExecDraw(void)
{
	if(Img.isDraw == FALSE)
	{
		return;
	}

	ImgDrawBg();
	ImgDrawChr();
	Img.isDraw = FALSE;
}
//---------------------------------------------------------------------------
EWRAM_CODE void ImgExecDrawFace(void)
{
	if(Img.isDrawFace == FALSE || Img.isDraw == TRUE)
	{
		return;
	}

	ImgDrawFace();
	Img.isDrawFace = FALSE;
}
//---------------------------------------------------------------------------
EWRAM_CODE void ImgExecDrawEffect(void)
{
	if(Img.isEffect == FALSE || Img.isDraw == TRUE)
	{
		return;
	}


	if(Img.waitCnt != 0)
	{
		Img.waitCnt--;
		return;
	}
	Img.waitCnt = Img.waitNum;


	switch(Img.effectNo)
	{
	case IMG_EFFECT_03:
		ImgExecEffect03();
		break;

	case IMG_EFFECT_04:
		ImgExecEffect04();
		break;

	case IMG_EFFECT_06:
		ImgExecEffect06();
		break;

	case IMG_EFFECT_09:
	case IMG_EFFECT_05:			// p
	case IMG_EFFECT_32:			// p
		ImgExecEffect09();
		break;

	case IMG_EFFECT_12:
		ImgExecEffect12();
		break;

	case IMG_EFFECT_13:
		ImgExecEffect13();
		break;

	case IMG_EFFECT_14:
		ImgExecEffect14();
		break;

	case IMG_EFFECT_15:
		ImgExecEffect15();
		break;

	case IMG_EFFECT_16:
		ImgExecEffect16();
		break;

	case IMG_EFFECT_17:
		ImgExecEffect17();
		break;

	case IMG_EFFECT_18:
		ImgExecEffect18();
		break;

	case IMG_EFFECT_20:
		ImgExecEffect20();
		break;

	case IMG_EFFECT_23:
	case IMG_EFFECT_22:			// p
		ImgExecEffect23();
		break;

	case IMG_EFFECT_NORMAL:
		ImgExecEffectNormal();
		break;

	case IMG_EFFECT_BLACK_OUT:
		ImgExecEffectBlackOut();
		break;

	case IMG_EFFECT_BLACK_IN:
		ImgExecEffectBlackIn();
		break;

	case IMG_EFFECT_WHITE_OUT:
		ImgExecEffectWhiteOut();
		break;

	case IMG_EFFECT_WHITE_IN:
		ImgExecEffectWhiteIn();
		break;

	case IMG_EFFECT_SCROLL_ED:
		ImgExecEffectScrollEd();
		break;

	case IMG_EFFECT_SCROLL_UD:
		ImgExecEffectScrollUd();
		break;

	case IMG_EFFECT_SCROLL_DU:
		ImgExecEffectScrollDu();
		break;

	case IMG_EFFECT_SCROLL_D:
		ImgExecEffectScrollD();
		break;

	default:
		SystemError("[Err] ImgExec Img.effectNo=%d\n", Img.effectNo);
		break;
	}
}
//---------------------------------------------------------------------------
// PC΂㉺dˍ킹
EWRAM_CODE void ImgExecEffect03(void)
{
	u32 y1 = (Img.step * 2) + 1;
	u32 y2 = 158 - (Img.step * 2);

	Mode3Copy(0, y1, 239, y1);
	Mode3Copy(0, y2, 239, y2);

	Img.step++;

	if(Img.step >= 80)
	{
		Img.isEffect = FALSE;
	}
}
//---------------------------------------------------------------------------
// PC΂Edˍ킹
EWRAM_CODE void ImgExecEffect04(void)
{
	u32 x1 = (Img.step * 2) + 1;
	u32 x2 = 238 - (Img.step * 2);

	Mode3Copy(x1, 0, x1, 159);
	Mode3Copy(x2, 0, x2, 159);

	Img.step++;

	if(Img.step >= 120)
	{
		Img.isEffect = FALSE;
	}
}
//---------------------------------------------------------------------------
// UShbgubNO
EWRAM_CODE void ImgExecEffect06(void)
{
	u32 x, y;
	u32 idx = Img.step;

	for(y=7; y<160; y+=16)
	{
		for(x=7; x<240; x+=16)
		{
			Mode3Copy(x-idx, y-idx, x+idx, y+idx);
		}
	}

	if(idx >= 7)
	{
		ImgExecEffectNormal();
	}

	Img.step++;
}
//---------------------------------------------------------------------------
// 킶SSij
EWRAM_CODE void ImgExecEffect09(void)
{
	u32 cx[4] = { 0, 3, 0, 3 };
	u32 cy[4] = { 0, 3, 3, 0 };
	u32 x;
	u32 y;
	u32 idx = Img.step;

	for(y=0; y<160; y+=8)
	{
		for(x=0; x<240; x+=8)
		{
			Mode3Copy(x+cx[idx], y+cy[idx], x+cx[idx]+4, y+cy[idx]+4);
		}
	}

	if(idx >= 3)
	{
		Img.isEffect = FALSE;
	}

	Img.step++;
}
//---------------------------------------------------------------------------
// E
EWRAM_CODE void ImgExecEffect12(void)
{
	u32 x = Img.step * 8;

	Mode3Copy(x, 0, x+7, 159);

	Img.step++;
	if(Img.step >= 30)
	{
		Img.isEffect = FALSE;
	}
}
//---------------------------------------------------------------------------
// E
EWRAM_CODE void ImgExecEffect13(void)
{
	u32 x = 232 - (Img.step * 8);

	Mode3Copy(x, 0, x+7, 159);

	Img.step++;
	if(Img.step >= 30)
	{
		Img.isEffect = FALSE;
	}
}
//---------------------------------------------------------------------------
// と
EWRAM_CODE void ImgExecEffect14(void)
{
	u32 y = Img.step * 8;

	Mode3Copy(0, y, 239, y+7);

	Img.step++;
	if(Img.step >= 20)
	{
		Img.isEffect = FALSE;
	}
}
//---------------------------------------------------------------------------
// 
EWRAM_CODE void ImgExecEffect15(void)
{
	u32 y = Img.step * 8;
	Mode3Copy(0, 159-y-7, 239, 159-y);

	Img.step++;
	if(Img.step >= 20)
	{
		Img.isEffect = FALSE;
	}
}
//---------------------------------------------------------------------------
// cCL
EWRAM_CODE void ImgExecEffect16(void)
{
	u32 w = Img.step;
	u32 i;

	for(i=0; i<240; i+=8)
	{
		Mode3Copy(i+w, 0, i+w, 159);
	}

	Img.step++;
	if(Img.step >= 8)
	{
		Img.isEffect = FALSE;
	}
}
//---------------------------------------------------------------------------
// CL
EWRAM_CODE void ImgExecEffect17(void)
{
	u32 w = Img.step;
	u32 i;

	for(i=0; i<160; i+=8)
	{
		Mode3Copy(0, i+w, 239, i+w);
	}

	Img.step++;
	if(Img.step >= 8)
	{
		Img.isEffect = FALSE;
	}
}
//---------------------------------------------------------------------------
// cCO
EWRAM_CODE void ImgExecEffect18(void)
{
	u32 x = (Img.step / 8) * 8;
	u32 w = Mod(Img.step, 8);
	u32 i;

	for(i=0; i<240; i+=16)
	{
		Mode3Copy(i+x+w, 0, i+x+w, 159);
		Mode3Copy(i+x+15-w, 0, i+x+15-w, 159);
	}

	Img.step++;
	if(Img.step >= 8)
	{
		Img.isEffect = FALSE;
	}
}
//---------------------------------------------------------------------------
// CO
EWRAM_CODE void ImgExecEffect20(void)
{
	u32 y = (Img.step / 8) * 8;
	u32 w = Mod(Img.step, 8);
	u32 i;

	for(i=0; i<160; i+=16)
	{
		Mode3Copy(0, i+y+w, 239, i+y+w);
		Mode3Copy(0, i+y+15-w, 239, i+y+15-w);
	}

	Img.step++;
	if(Img.step >= 8)
	{
		Img.isEffect = FALSE;
	}
}
//---------------------------------------------------------------------------
// 킶QQij
EWRAM_CODE void ImgExecEffect23(void)
{
	u32 cx[4] = { 0, 1, 0, 1 };
	u32 cy[4] = { 0, 1, 1, 0 };
	u32 x;
	u32 y;
	u32 idx = Img.step;

	for(y=0; y<160; y+=4)
	{
		for(x=0; x<240; x+=4)
		{
			Mode3Copy(x+cx[idx], y+cy[idx], x+cx[idx]+2, y+cy[idx]+2);
		}
	}

	if(idx >= 3)
	{
		Img.isEffect = FALSE;
	}

	Img.step++;
}
//---------------------------------------------------------------------------
// P\
EWRAM_CODE void ImgExecEffectNormal(void)
{
	Mode3SetDrawBuf();

	Img.isEffect = FALSE;
}
//---------------------------------------------------------------------------
// ubNAEg
EWRAM_CODE void ImgExecEffectBlackOut(void)
{
	u32 cnt = 16 - Img.step++;

	FadeSetBlack(cnt);

	if(cnt == 16)
	{
		Mode3SetDrawBuf();
	}
	else if(cnt <= Img.fadeCnt)
	{
		FadeSetBlack(Img.fadeCnt);
		Img.isEffect = FALSE;
	}
}
//---------------------------------------------------------------------------
// ubNC
EWRAM_CODE void ImgExecEffectBlackIn(void)
{
	u32 cnt = Img.fadeCnt + Img.step++;

	FadeSetBlack(cnt);

	if(cnt == 15)
	{
		Mode3DrawFill(RGB5(0, 0, 0));
		Mode3SetDrawBuf();

		ImgSetBg(0);
	}
	else if(cnt >= 16)
	{
		FadeSetBlack(Img.fadeCnt);
		Img.isEffect = FALSE;
	}
}
//---------------------------------------------------------------------------
// zCgAEg
EWRAM_CODE void ImgExecEffectWhiteOut(void)
{
	u32 cnt = 16 - Img.step++;

	FadeSetWhite(cnt);

	if(cnt == 16)
	{
		Mode3SetDrawBuf();
	}
	else if(cnt <= Img.fadeCnt)
	{
		FadeSetBlack(Img.fadeCnt);
		Img.isEffect = FALSE;
	}
}
//---------------------------------------------------------------------------
// zCgC
EWRAM_CODE void ImgExecEffectWhiteIn(void)
{
	u32 cnt = Img.fadeCnt + Img.step++;

	FadeSetWhite(cnt);

	if(cnt == 15)
	{
		Mode3DrawFill(RGB5(31, 31, 31));
		Mode3SetDrawBuf();

		ImgSetBg(0);
	}
	else if(cnt >= 16)
	{
		Img.isEffect = FALSE;
	}
}
//---------------------------------------------------------------------------
// X^btNWbgpXN[
EWRAM_CODE void ImgExecEffectScrollEd(void)
{
	Mode3ScrollEd();
	Img.isEffect = FALSE;
}
//---------------------------------------------------------------------------
// とXN[
EWRAM_CODE void ImgExecEffectScrollUd(void)
{
	Mode3Scroll(Img.step);

	if(Img.step == 160)
	{
		Img.isEffect = FALSE;
	}
	Img.step++;
}
//---------------------------------------------------------------------------
// XN[
EWRAM_CODE void ImgExecEffectScrollDu(void)
{
	Mode3Scroll(160 - Img.step);

	if(160 - Img.step == 0)
	{
		Img.isEffect = FALSE;
	}
	Img.step++;
}
//---------------------------------------------------------------------------
// ŒXN[
EWRAM_CODE void ImgExecEffectScrollD(void)
{
	Mode3Scroll(160);
	Img.isEffect = FALSE;
}
//---------------------------------------------------------------------------
EWRAM_CODE void ImgDrawBg(void)
{
	// V́iV@ҁjΉ
	if(Img.bgNo == 0 && Img.chrNo == 616)
	{
		Mode3DrawFill(RGB5(31, 31, 31));
		return;
	}

	if(Img.bgNo == 0)
	{
		Mode3DrawFill(RGB5(0, 0, 0));
		return;
	}


	ST_IMG_HEADER* p1 = (ST_IMG_HEADER*)FileGetImg(Img.bgNo);

	if((p1->cx == 240 && p1->cy == 160) || (p1->cx == 240 && p1->cy == 320))
	{
		Mode3DrawBg((u16*)(p1 + 1));
		return;
	}

	ST_IMG_HEADER* p2 = (ST_IMG_HEADER*)FileGetImg(1);

	Mode3DrawBg((u16*)(p2 + 1));
	Mode3DrawBgSmall((u16*)(p1 + 1));
}
//---------------------------------------------------------------------------
EWRAM_CODE void ImgDrawChr(void)
{
	if(Img.chrNo == 0)
	{
		return;
	}

	ST_IMG_HEADER* p  = (ST_IMG_HEADER*)FileGetImg(Img.chrNo);
	ST_IMG_HEADER* pM = (ST_IMG_HEADER*)FileGetImgMask(Img.chrNo);

	// ʒu
	u32 x = 240 - p->cx;
	u32 y = 160 - p->cy;

	if(x >= 240 / 2)
	{
		x -= 20;
	}

	// ŔiijW`G̐퓬p
	if(Img.chrNo >= 359 && Img.chrNo <= 364)
	{
		x = (240 / 2) - (p->cx / 2);
	}

	// V́iV@ҁjAA̗EBN
	if(Img.chrNo == 575)
	{
		x = 154;
	}

	Mode3DrawBlend(x, y, p->cx, p->cy, (u16*)(p + 1), (u16*)(pM + 1));
}
//---------------------------------------------------------------------------
EWRAM_CODE void ImgDrawFace(void)
{
	if(Img.faceNo == 0)
	{
		return;
	}

	ST_IMG_HEADER* p = (ST_IMG_HEADER*)FileGetImg(Img.faceNo);

	Mode3DrawFace((u16*)(p + 1));
	Mode3SetDrawFace();
}
//---------------------------------------------------------------------------
EWRAM_CODE void ImgSetBg(u32 no)
{
	TRACEOUT("[SetBg no:%d]\n", no);

	Img.bgNo   = no;
	Img.chrNo  = 0;
	Img.faceNo = 0;
}
//---------------------------------------------------------------------------
// gA摜^Cv̊mFĂZbg܂
// ėpIȈׁAi͎gȂ悤ɁB
EWRAM_CODE void ImgSetSelect(u32 no)
{
	if(FileIsMaskExist(no) == TRUE)
	{
		ImgSetChr(no);
		return;
	}

	ImgSetBg(no);
}
//---------------------------------------------------------------------------
EWRAM_CODE void ImgSetChr(u32 no)
{
	TRACEOUT("[SetChr no:%d]\n", no);

	Img.chrNo = no;
}
//---------------------------------------------------------------------------
EWRAM_CODE void ImgSetFace(u32 no)
{
	TRACEOUT("[SetFace no:%d]\n", no);

	Img.faceNo = no;
	Img.isDrawFace = TRUE;
}
//---------------------------------------------------------------------------
EWRAM_CODE void ImgSetEffect(u32 no, u32 wait)
{
	TRACEOUT("[SetEffect no:%d wait:%d]\n", no , wait);

	Img.effectNo = no;
	Img.waitNum  = wait;
	Img.waitCnt  = 0;
	Img.step     = 0;

	Img.isDraw   = TRUE;
	Img.isEffect = TRUE;
}
//---------------------------------------------------------------------------
EWRAM_CODE void ImgSetEffectOnly(u32 no, u32 wait)
{
	ImgSetEffect(no, wait);
	Img.isDraw = FALSE;
}
//---------------------------------------------------------------------------
EWRAM_CODE void ImgSetFade(u32 cnt)
{
	Img.fadeCnt = cnt;
	FadeSetBlack(cnt);
}
//---------------------------------------------------------------------------
EWRAM_CODE u32 ImgGetFade(void)
{
	return Img.fadeCnt;
}
//---------------------------------------------------------------------------
EWRAM_CODE void ImgDirectCrop(u32 no, u32 x, u32 y)
{
	ST_IMG_HEADER* p = (ST_IMG_HEADER*)FileGetImg(no);

	Mode3DrawCrop(x, y, p->cx, p->cy, (u16*)(p + 1));
}
//---------------------------------------------------------------------------
EWRAM_CODE void ImgDirectClip(u32 no, u32 x, u32 y, u32 gx, u32 gy, u32 gs)
{
	ST_IMG_HEADER* p = (ST_IMG_HEADER*)FileGetImg(no);

	Mode3DrawClip(x, y, p->cx, p->cy, gx, gy, gs, (u16*)(p + 1));
}
//---------------------------------------------------------------------------
EWRAM_CODE void ImgDirectBlend(u32 no, u32 x, u32 y)
{
	ST_IMG_HEADER* p  = (ST_IMG_HEADER*)FileGetImg(no);
	ST_IMG_HEADER* pM = (ST_IMG_HEADER*)FileGetImgMask(no);

	Mode3DrawBlend(x, y, p->cx, p->cy, (u16*)(p + 1), (u16*)(pM + 1));
}
//---------------------------------------------------------------------------
EWRAM_CODE void ImgDirectLine(u32 no, u32 cnt)
{
	ST_IMG_HEADER* p  = (ST_IMG_HEADER*)FileGetImg(no);

	Mode3DrawLine(cnt, (u16*)(p + 1));
}
//---------------------------------------------------------------------------
EWRAM_CODE void ImgDirectFill(u32 col)
{
	Mode3DrawFill(col);
}
//---------------------------------------------------------------------------
EWRAM_CODE bool ImgIsEnd(void)
{
	return (Img.isDraw == FALSE && Img.isDrawFace == FALSE && Img.isEffect == FALSE) ? TRUE : FALSE;
}
