#ifndef __IMG_H__
#define __IMG_H__
#ifdef __cplusplus
extern "C" {
#endif


#include "libgba/gba.h"

//---------------------------------------------------------------------------
// TODO 5, 22, 32, 64 ͖

enum {
	IMG_EFFECT_03 = 3,			// PC΂㉺dˍ킹
	IMG_EFFECT_04 = 4,			// PC΂Edˍ킹
	IMG_EFFECT_05 = 5,			// s͗l
	IMG_EFFECT_06 = 6,			// UShbgubNO
	IMG_EFFECT_09 = 9,			// 킶SSij
	IMG_EFFECT_12 = 12,			// E
	IMG_EFFECT_13 = 13,			// E
	IMG_EFFECT_14 = 14,			// と
	IMG_EFFECT_15 = 15,			// 
	IMG_EFFECT_16 = 16,			// cCL
	IMG_EFFECT_17 = 17,			// CL
	IMG_EFFECT_18 = 18,			// cCO
	IMG_EFFECT_20 = 20,			// CO
	IMG_EFFECT_22 = 22,			// 킶QQi傫j
	IMG_EFFECT_23 = 23,			// 킶QQij
	IMG_EFFECT_32 = 32,			// UCNNXtF[h
	IMG_EFFECT_NV_END,

	IMG_EFFECT_NORMAL    = 500,	// P\
	IMG_EFFECT_BLACK_OUT = 501,	// ubNAEg
	IMG_EFFECT_BLACK_IN  = 502,	// ubNC
	IMG_EFFECT_WHITE_OUT = 503,	// zCgAEg
	IMG_EFFECT_WHITE_IN  = 504,	// zCgC
	IMG_EFFECT_SCROLL_ED = 505,	// X^btNWbgpXN[
	IMG_EFFECT_SCROLL_UD = 506,	// とXN[
	IMG_EFFECT_SCROLL_DU = 507,	// XN[
	IMG_EFFECT_SCROLL_D  = 508,	// ŒXN[
	IMG_EFFECT_END,
};


//---------------------------------------------------------------------------
typedef struct {
	bool isDraw;
	bool isDrawFace;
	bool isEffect;

	u32  bgNo;
	u32  chrNo;
	u32  faceNo;

	u32  effectNo;
	u32  waitCnt;
	u32  waitNum;
	u32  step;

	u32  fadeCnt;

} ST_IMG;


//---------------------------------------------------------------------------
EWRAM_CODE void ImgInit(void);

EWRAM_CODE void ImgExec(void);
EWRAM_CODE void ImgExecDraw(void);
EWRAM_CODE void ImgExecDrawFace(void);
EWRAM_CODE void ImgExecDrawEffect(void);

EWRAM_CODE void ImgExecEffect03(void);
EWRAM_CODE void ImgExecEffect04(void);
EWRAM_CODE void ImgExecEffect06(void);
EWRAM_CODE void ImgExecEffect09(void);
EWRAM_CODE void ImgExecEffect12(void);
EWRAM_CODE void ImgExecEffect13(void);
EWRAM_CODE void ImgExecEffect14(void);
EWRAM_CODE void ImgExecEffect15(void);
EWRAM_CODE void ImgExecEffect16(void);
EWRAM_CODE void ImgExecEffect17(void);
EWRAM_CODE void ImgExecEffect18(void);
EWRAM_CODE void ImgExecEffect20(void);
EWRAM_CODE void ImgExecEffect23(void);
EWRAM_CODE void ImgExecEffectNormal(void);
EWRAM_CODE void ImgExecEffectBlackOut(void);
EWRAM_CODE void ImgExecEffectBlackIn(void);
EWRAM_CODE void ImgExecEffectWhiteOut(void);
EWRAM_CODE void ImgExecEffectWhiteIn(void);
EWRAM_CODE void ImgExecEffectScrollEd(void);
EWRAM_CODE void ImgExecEffectScrollUd(void);
EWRAM_CODE void ImgExecEffectScrollDu(void);
EWRAM_CODE void ImgExecEffectScrollD(void);

EWRAM_CODE void ImgDrawBg(void);
EWRAM_CODE void ImgDrawChr(void);
EWRAM_CODE void ImgDrawFace(void);

EWRAM_CODE void ImgSetBg(u32 no);
EWRAM_CODE void ImgSetSelect(u32 no);
EWRAM_CODE void ImgSetChr(u32 no);
EWRAM_CODE void ImgSetFace(u32 no);
EWRAM_CODE void ImgSetEffect(u32 no, u32 wait);
EWRAM_CODE void ImgSetEffectOnly(u32 no, u32 wait);
EWRAM_CODE void ImgSetFade(u32 cnt);
EWRAM_CODE u32  ImgGetFade(void);

EWRAM_CODE void ImgDirectCrop(u32 no, u32 x, u32 y);
EWRAM_CODE void ImgDirectClip(u32 no, u32 x, u32 y, u32 gx, u32 gy, u32 gs);
EWRAM_CODE void ImgDirectBlend(u32 no, u32 x, u32 y);
EWRAM_CODE void ImgDirectLine(u32 no, u32 cnt);
EWRAM_CODE void ImgDirectFill(u32 col);
EWRAM_CODE bool ImgIsEnd(void);


#ifdef __cplusplus
}
#endif
#endif
