#ifndef __KEY_H__
#define __KEY_H__
#ifdef __cplusplus
extern "C" {
#endif

#include "../libgba/gba.h"


//---------------------------------------------------------------------------
#define KEY_MAX_BTN_CNT		10
#define KEY_REPEAT_CNT		10


enum {
	SYS_KEY_A,
	SYS_KEY_B,
	SYS_KEY_SL,
	SYS_KEY_ST,
	SYS_KEY_RI,
	SYS_KEY_LE,
	SYS_KEY_UP,
	SYS_KEY_DO,
	SYS_KEY_R,
	SYS_KEY_L,
};

//---------------------------------------------------------------------------
typedef struct {
	u32 tmp[KEY_MAX_BTN_CNT];	// {^̔p
	u32 cnt;					// ݂̃L[
	u32 trg;					// ꂽL[
	u32 off;					// ꂽL[
	u32 rep;					// s[gL[
	s32 repCnt;					// s[gJEg
} ST_KEY;


//---------------------------------------------------------------------------
EWRAM_CODE void KeyInit(void);
IWRAM_CODE void KeyExec(void);

EWRAM_CODE u16  KeyGetCnt(void);
EWRAM_CODE u16  KeyGetTrg(void);
EWRAM_CODE u16  KeyGetOff(void);
EWRAM_CODE u16  KeyGetRep(void);

EWRAM_CODE bool KeyIsCntAB(void);
EWRAM_CODE bool KeyIsTrgAB(void);

EWRAM_CODE bool KeyChangeBotton(u32 b1, u32 b2);


#ifdef __cplusplus
}
#endif
#endif
