#ifndef __NV_H__
#define __NV_H__
#ifdef __cplusplus
extern "C" {
#endif


#include "libgba/gba.h"

//---------------------------------------------------------------------------
#define NV_MAX_VAR_CNT				200
#define NV_MAX_CALC_CNT				16
#define NV_MAX_CALL_CNT				16
#define NV_MAX_MSG_SIZE				200
#define NV_MAX_SEL_CNT				10
#define NV_MAX_SEL_BUF_SIZE			32


enum {
	NV_ACT_PARSE,
	NV_ACT_KEY,
	NV_ACT_SELECT,
	NV_ACT_END_READY,
	NV_ACT_END,
};

//---------------------------------------------------------------------------
typedef struct {
	// 
	u32   act;
	u32   actStep;
	s32   waitCnt;
	bool  isLoop;
	bool  isSkip;							// bZ[WGtFNgXLbv

	// Q[֌W
	u8*   pHead;							// wb_ʒu
	u8*   pCur;								// J[\
	s16   var[NV_MAX_VAR_CNT];				// ϐ

	// bZ[W
	s32   msgCnt;
	u8    msg[NV_MAX_MSG_SIZE] ALIGN(4);

	// R[e[u
	s32   callCnt;
	u32   callNo[NV_MAX_CALL_CNT];
	u32   callAdr[NV_MAX_CALL_CNT];

	// t|[hvZp
	s32   calcCnt;
	u32   calcTbl[NV_MAX_CALC_CNT];

	// I
	s32   sel;
	s32   selCnt;							// o^
	u32   selAdr[NV_MAX_SEL_CNT];
	u16   selBuf[NV_MAX_SEL_CNT][NV_MAX_SEL_BUF_SIZE];

	// XNvgf[^
	u32   datAdr;							// f[^̊Jn擪AhX
	u32   size;								// t@CTCY
	u32   no;								// f[^ԍ

} ST_NV;


//---------------------------------------------------------------------------
EWRAM_CODE void NvInit(void);

EWRAM_CODE void NvExec(void);
EWRAM_CODE void NvExecKey(void);
EWRAM_CODE bool NvExecKeySub(void);
EWRAM_CODE void NvExecSelect(void);
EWRAM_CODE void NvExecEndReady(void);

EWRAM_CODE void NvSetAct(u32 act);
EWRAM_CODE void NvSetSco(u32 no, u32 adr);
EWRAM_CODE void NvSetSkip(bool is);
EWRAM_CODE void NvSetCapter(u32 no);
EWRAM_CODE void NvSetVar(u16 num, u16 val);
EWRAM_CODE u16  NvGetVar(u16 num);

EWRAM_CODE bool NvIsEnd(void);


#ifdef __cplusplus
}
#endif
#endif

