#ifndef __NV2_H__
#define __NV2_H__
#ifdef __cplusplus
extern "C" {
#endif


#include "libgba/gba.h"

//---------------------------------------------------------------------------


//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
EWRAM_CODE void NvExecParse(void);
EWRAM_CODE void NvExecParseMsg(void);
EWRAM_CODE void NvExecParseCmd(void);

EWRAM_CODE void NvExecParseAssign(void);
EWRAM_CODE void NvExecParseSelect(void);
EWRAM_CODE void NvExecParsePageCall(void);
EWRAM_CODE void NvExecParseJump(void);
EWRAM_CODE void NvExecParseFor(void);
EWRAM_CODE void NvExecParseJumpAdr(void);
EWRAM_CODE void NvExecParseWindow(void);
EWRAM_CODE void NvExecParseCopy(void);
EWRAM_CODE void NvExecParseScreenClear(void);
EWRAM_CODE void NvExecParseImage(void);
EWRAM_CODE void NvExecParseShowVar(void);
EWRAM_CODE void NvExecParseKeyWait(void);
EWRAM_CODE void NvExecParseImageOption(void);
EWRAM_CODE void NvExecParseArray(void);
EWRAM_CODE void NvExecParseScreen(void);
EWRAM_CODE void NvExecParseScreenFadeBlack(void);
EWRAM_CODE void NvExecParseScreenFadeWhite(void);
EWRAM_CODE void NvExecParseLf(void);
EWRAM_CODE void NvExecParseExtensionCmd(void);
EWRAM_CODE void NvExecParseSystem(void);
EWRAM_CODE void NvExecParseLabelCall(void);
EWRAM_CODE void NvExecParseSelectStart(void);
EWRAM_CODE void NvExecParseIf(void);
EWRAM_CODE void NvExecParseLabelCallFar(void);

EWRAM_CODE void NvCalc(void);
EWRAM_CODE void NvCalcVar(void);
EWRAM_CODE u16  NvCalcGet(void);
EWRAM_CODE void NvCalcPush(u16 num);
EWRAM_CODE u16  NvCalcPop(void);

EWRAM_CODE void NvCallPush(u16 no, u32 adr);
EWRAM_CODE void NvCallPushPatch(u16 no, u32 adr);
EWRAM_CODE void NvCallPop(void);

EWRAM_CODE void NvMsg(void);
EWRAM_CODE void NvEffect(u32 idx, u32 wait);
EWRAM_CODE void NvEffectNoSkip(u32 idx, u32 wait);
EWRAM_CODE void NvAnime(u32 no);

EWRAM_CODE u16  NvCurU16(void);
EWRAM_CODE u32  NvCurU32(void);


#ifdef __cplusplus
}
#endif
#endif
