/*
 * cg.h  Cg˴ؤƼ
 *
 * Copyright (C) 1997-1998 Masaki Chikama (Wren) <chikama@kasumi.ipl.mech.nagoya-u.ac.jp>
 *               1998-                           <masaki-c@is.aist-nara.ac.jp>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
*/
/* $Id: cg.h,v 1.1.1.1 1999/04/17 13:14:15 chikama Exp $ */

#ifndef __CG__
#define __CG__

#include "portab.h"

typedef struct {
	BYTE red[256];
	BYTE green[256];
	BYTE blue[256];
} Pallet256;

typedef struct {
	BYTE r,g,b;
	DWORD pixel;
} Pallet;

typedef struct {
	int pmsVer;
	int pmsHdrSize;
	int pmsBpp;
	int pmsBppS;
	int pmsSf;
	int pmsBf;
	int pmsX0;
	int pmsY0;
	int pmsXW;
	int pmsYW;
	int pmsDp;
	int pmsPp;
	int pmsCp;
} Pms_header;

typedef struct {
	int vspX0;
	int vspY0;
	int vspXW;
	int vspYW;
	int vspPb;
	int vspPp;
	int vspDp;
} Vsp_header;

typedef enum {
	BMP_OS2 = 1,
	BMP_WIN = 2
} BMP_Type;

typedef struct {
	int bmpSize;
	/*data[4]-data[7]reserv*/
	int bmpXW;
	int bmpYW;
	int bmpBpp;
	int bmpCp;
	int bmpImgSize;
	int bmpDp;
	int bmpPp;
	BMP_Type bmpTp;
} Bmp_header;
 
typedef struct {
	int x;
	int y;
} MyPoint;

typedef struct {
	int width;
	int height;
} MyDimension;

typedef struct {
	int x;
	int y;
	int width;
	int height;
} MyRectangle;

typedef enum {
	ALCG_UNKNOWN = 1,
	ALCG_VSP     = 2,
	ALCG_PMS8    = 3,
	ALCG_PMS16   = 4,
	ALCG_BMP8    = 5,
	ALCG_BMP24   = 6
} CG_TYPE;

typedef struct {
	CG_TYPE type;
	int     x;
	int     y;
	int     width;
	int     height;
	BYTE    *byte_pic;
	WORD    *word_pic;
	int     spritecolor;
	int     alphaLevel;
	boolean hasAlpha;
	boolean hasSprite;
} CG_INFO;


/* defined by vsp.c */
extern boolean Vsp_checkFmt(const BYTE *data);
extern void Vsp_expandCg(const BYTE *data, BYTE *pic);
extern Vsp_header *Vsp_getCgInfo();
extern void Vsp_getInitLoc(MyPoint *p);
extern void Vsp_getSize(MyDimension *d);
extern Pallet256 *Vsp_getPallet();

/*defined by pms256.c */
extern boolean Pms256_checkFmt(const BYTE *data);
extern void Pms256_expandCg(const BYTE *data, BYTE *pic);
extern Pms_header *Pms256_getCgInfo();
extern void Pms256_getInitLoc(MyPoint *p);
extern void Pms256_getSize(MyDimension *d);
extern Pallet256 *Pms256_getPallet();
/* defined by pms64k.c */
extern boolean Pms64k_checkFmt(const BYTE *data);
extern void Pms64k_expandCg(const BYTE *data,WORD *pic, boolean *hasAlph, BYTE *shade);
extern Pms_header *Pms64k_getCgInfo();
extern void Pms64k_getInitLoc(MyPoint *p);
extern void Pms64k_getSize(MyDimension *d);
/* defined by bmp16m.c */
extern boolean Bmp16m_checkFmt(const BYTE *data);
extern void Bmp16m_expandCg(const BYTE *data, WORD *pic);
extern Bmp_header * Bmp16m_getCgInfo();
extern void Bmp16m_getInitLoc(MyPoint *p);
extern void Bmp16m_getSize(MyDimension *d);
/*defined by bmp256.c */
extern boolean Bmp256_checkFmt(const BYTE *data);
extern void Bmp256_expandCg(const BYTE *data, BYTE *pic);
extern Bmp_header *Bmp256_getCgInfo();
extern void Bmp256_getInitLoc(MyPoint *p);
extern void Bmp256_getSize(MyDimension *d);
extern Pallet256 *Bmp256_getPallet();

#endif /* !__CG__ */
